// Anforderung eines Helis zum Transport an einen Zielort, welcher ber
//  einen Klick auf die Karte bestimmt wird. [Vienna 30.08.2011]
//
// Aufrufbeispiel fr ein Aktionsmen: player addAction ["*** Helitransport anfordern ***", "myHeli\myHeli.sqf",[2,80,1000,3],-1,false,true,""];
// Paramter bei AddAction:  ...myHeli.sqf",[2,80,1000,3],-1,... 
//      die    2 steht fr die Anzahl der Wegpunkte auf der Karte
//      die   80 fr die Flughhe beim Zielpunkt          
//      die 1000 fr den Abstand des Helis bei der Erstellung zum Abholort
//      die    3 fr die Geschwindigkeit. 1 = langsam, 2 = normal, 3 = schnell. 
//               Bei 1: Geschwindigkeit ca.  50 km/h, Flughhe ca. 100 m
//               Bei 2: Geschwindigkeit     100 km/h, Flughhe ca.  75 m
//               Bei 3: Geschwindigkeit ca. 200 km/h, Flughhe ca.  50 m
//              Die Flughhe beim Zielpunkt bleibt unverndert.         
//
// Verwendet Skripts: "myHeliInfo.sqf" und "myHeliWaypoints.sqf"


//globale Variable beim ersten Aufruf fr Bestimmung ob ein Heli aktiv ist.
	if (isNil "myHeliAktiv") then {myHeliAktiv = false};
//Skript beenden falls bereits ein Heli akiv ist
	if(myHeliAktiv) exitWith {player groupChat "Alle Helis im Einsatz! Warten auf Bereit-Meldung!"};


// lokale Variable
	private ["_speed_limit","_speed_bremse","_clearAllWP","_addWP","_Mk","_info","_t","_l","_h","_p","_wp","_s","_i","_maxWPs","_endH","_dErst","_geschA","_geschN","_dis"];


// ******************* UNTERPROGRAMME *************************************************************************

//Begrenzt die Geschwindigkeit eines Helis 
//Parameter [Heli, ZielPosition, aktiv bis Meter vor Ziel, max.Geschwindigkeit]
_speed_limit =
  {
    [_this select 0, _this select 1, _this select 2, _this select 3] spawn
      {
        private ["_heli","_ziel","_distanz","_speed"];
        _heli    = _this select 0;
        _ziel    = _this select 1;
        _distanz = _this select 2;
        _speed   = _this select 3;
        while {alive _heli AND _heli distance _ziel > _distanz} do
         {
           _heli limitSpeed _speed
         }
      } 
  };

//Heli-Geschwindigkeit langsam ohne Aufsteigen drosseln. 
//Parameter [Heli, ZielPosition, aktiv bis Meter unmittelbar vor Ziel]
_speed_bremse =
  {
    [_this select 0, _this select 1, _this select 2] spawn
      {
        private ["_heli","_ziel","_distanz","_v1","_v2","_v3a","_v4a","_v3b","_v4b"];
        _heli    = _this select 0;
        _ziel    = _this select 1;
        _distanz = _this select 2;
        _v3a = -2;
        _v4a = -1;
        while {alive _heli AND _heli distance _ziel > _distanz} do
          {
            _v1  = velocity  _heli;
            _v2  = direction _heli;
            _v3b = 1;
            _v4b = 1;
            if (speed _heli > 50) then {_v3b = _v3a};
            if (getPos _heli select 2 > 30) then {_v4b = _v4a};
            _heli setVelocity [(_v1 select 0)+(sin _v2*_v3b),(_v1 select 1)+(cos _v2*_v3b),(_v1 select 2)+_v4b];  
            sleep 0.5  
          }
       }
  };
  
//Funktion alle Wegpunkgte lschen. Aufurf: <Objekt> call _clearAllWP
	_clearAllWP = compile "private['_w'];for[{_w=Count Waypoints _this},{_w>=0},{_w=_w-1}]do{deleteWaypoint[group _this,_w]}";

//Funktion Wegpunkt hinzufgen. Aufruf: [<Objekt>,[<Position>],"Type"] call _addWP
	_addWP = compile "Private['_w'];_w=group(_this select 0)AddWaypoint[_this select 1,Count Waypoints (_this select 0)];_w SetWaypointType (_this select 2);_w ShowWaypoint'always';_w";

// ************************************************************************************************************


//globale Variable fr Zielposition
	myHeliZielPosition = [];

// Parameter bernehmen
  //Anzahl der Wegpunkte
    _maxWPs = (_this select 3)select 0;
  //Hhe beim Zielanflug
    _endH   = (_this select 3)select 1;
  //Hhe beim Zielanflug
    _dErst  = (_this select 3)select 2;
  //Geschwindigkeit einstellen
    _t =      (_this select 3)select 3;
    _geschA = "NORMAL";
    _geschN = 35; //Flughhe des Helis = _geschN * 2
    if (_t == 1) then {_geschA = "LIMITED"; _geschN = 50};
    if (_t == 3) then {_geschA = "FULL";    _geschN = 25};

// _info: Textausgaben
	_info = [" -----> -----> -----> "];
	_info = _info + ["Heli im Anflug! Geschwindigkeit: "];
	_info = _info + ["Fliege zum Einsatzort! Geschwindigkeit: "];
	_info = _info + ["Abspringen oder warten bis Heli gelandet!"];
	_info = _info + ["Heli ist wieder bereit!"];
	_info = _info + ["Abflug zur Basis!"];
	_info = _info + ["Eintreffen beim Einsatzort!"];
	_info = _info + [""];
	_info = _info + ["Durch Klick in die Karte Landepunkte eintragen! Geschwindigkeit: "];
	_info = _info + ["Kein Landeplatz markiert!"];

//Marker erstellen
  _Mk = createMarkerLocal ["ViennasAbholMK", position player];
  _Mk setMarkerShapeLocal "ICON";
  _Mk setMarkerTypeLocal  "Select";
  _Mk setMarkerColorLocal "ColorRed";
  _Mk setMarkerSizeLocal  [1,1];
  _Mk setMarkerTextLocal  "Aufrufort";

//Anflugspunkt auf der Karte eintragen
  onMapSingleClick "myHeliZielPosition = _pos";

//Karte anzeigen 
  openMap [true, false];
  player groupChat format["%1%2",_info select 8,_geschA];

//Warten auf Kartenklick
  waitUntil {!visibleMap or count myHeliZielPosition > 0}; 

//Karte schlieen
  openMap [false, false]
  onMapSingleClick "";
  deleteMarkerLocal _Mk;

// Falls keine Position markiert, dann Skript verlassen
  if (count myHeliZielPosition == 0) exitWith {player groupChat format["%1",_info select 9]};

// globale Variable 
	myHeliAktiv = true;  // verhindert doppelte Anforderung des Helis

// _t: "Not-Ausstieg" nach ca. 3 Minuten "Leerlauf"
	_t = time + 180;

// _h: Heli
	_h = createVehicle ["Mi17_Civilian", myHeliZielPosition, [], _dErst, "FLY"];

// _p: Pilot
	if (playerSide == WEST) then 
    {_p = createGroup WEST createUnit ["USMC_Soldier_Pilot", [0,0], [], 0, "NONE"]}
	else
    {_p = createGroup EAST createUnit ["RU_Soldier_Pilot",   [0,0], [], 0, "NONE"]};
  _p setSkill 1;
	_p setBehaviour "careless";
	_p setCombatMode "BLUE";
	_p allowFleeing 0;
	_p moveInDriver _h;

// Pilot fliegt zu Abholort  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Heli Abflug
	player groupChat format["%1%2%3",_info select 0,_info select 1,_geschA];
  _h setPos [getPos _h select 0,getPos _h select 1,_geschN * 2];
	_h setspeedMode "LIMITED";
	_h flyinHeight _geschN * 2;
	_h doMove [getpos _h select 0,getpos _h select 1,_geschN * 2];
	sleep 7;

[1,_h,_p] execVM "myHeli\myHeliInfo.sqf"; //Skript fr Anzeige des Helistatus laden. <---------- 1.Aufruf
	
// _wp: fr Wegpunkthandhabung des Piloten  <================================= WEGPUNKT ZUM ABHOLORT
	_wp = group _p addWaypoint [myHeliZielPosition,0];
	[group _p, 0] SetWaypointType "move";
	group _p setCurrentWaypoint [group _p, 1];
	myHeliZielPosition = waypointPosition[group _p,(Count Waypoints _p)-1]; //Position vom Wegpunkt erforderlich fr korrektes Distance
	_h setspeedMode _geschA;

// _l: unsichtbares Lande H
	_l = "HeliHEmpty" createVehicleLocal myHeliZielPosition;
 
// Warten bis Pilot beim Spieler eintrifft
	waitUntil {_h distance myHeliZielPosition < 500 OR time > _t};
	
  [_h, myHeliZielPosition, 100] call _speed_bremse;   // <------------------------------------- Unterprogramm fr Geschwindigkeit abbremsen

	//Rauchgranate setzen
	"G_40mm_SmokeGreen" createVehicle getPos _l;
	
	waitUntil {_h distance myHeliZielPosition < 150 OR time > _t};  // +++++++++++++++++++++++++++ Heli Landung einleiten
	_h setspeedMode "LIMITED";
	_h flyinHeight 2;
	_h land "GET IN";

// Warten bis Spieler im Heli
	waitUntil {player in _h OR time > _t OR !(alive _p and _p IN _h)};
  _h land "NONE";
	if (time < _t and _p IN _h and alive _p) then 
		{
			// Warten bis Zielposition auf der Karte eingezeichnet
			ViennaMyHeliWP = 0;      // Fr Wegpunkte auf Karte setzen. 4 = Abflug
			myHeliZielPosition = []; // Beendet den 1. Aufruf von myHeliInfo.sqf 
			_maxWPs execVM "myHeli\myHeliWaypoints.sqf";  // Karte zum Eintragen der Wegpunkte aufrufen  <======== WEGPUNKT FR ZIELORT EINTRAGEN
			sleep 1;
			// Warten bis Zielort eingetragen
      waitUntil {ViennaMyHeliWP == 4 OR time > _t OR !visibleMap}; 
			onMapSingleClick "";    // Kartenklick lschen
			openMap [false, false]; //Karte schlieen

			// Pilot Zielort anfliegen   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ Heli Abflug
			if (time < _t and ViennaMyHeliWP == 4) then //Abflug zum Zielort
				{
          _t=_t+120;//verlngern der "Not-Ausstiegzeit"
					player groupChat format["%1%2%3",_info select 0,_info select 2,_geschA];

					//Pilot Heli hochziehen
        	_h setspeedMode "LIMITED";
					_h flyinHeight _geschN * 2;
 					_h doMove [getpos _h select 0,getpos _h select 1,_geschN * 2];
 					sleep 7;

					//Wegpunkte vom Spieler (ohne Wegpunkt 0) auf den Piloten bertragen    <=========================== WEGPUNKT ZUM ZIELORT BERNEHMEN
					_p call _clearAllWP;
					for [{_i=0},{Count Waypoints player > _i+1},{_i=_i+1}] do {[_p,waypointPosition[group player, _i+1],"MOVE"] call _addWP};
					player call _clearAllWP;
        	_h setspeedMode _geschA;

					//Neues Ziel in Publikvariable
					myHeliZielPosition = waypointPosition[group _p,(Count Waypoints _p)-1];  //Position vom Wegpunkt erforderlich fr korrektes Distance
          _l setPos myHeliZielPosition; //Lande-H auf Zielposition
					
					[2,_h,_p] execVM "myHeli\myHeliInfo.sqf"; //Skript fr Anzeige des Helistatus laden. <---------- 2. Aufruf
					
					_dis = _endH+600; // Distanz bis zu der der "Normalflug" abluft
          if (speedMode _h == "LIMITED") then {_dis = _endH+300};

          if (speedMode _h == "NORMAL") then
            {
              [_h, myHeliZielPosition, _dis-50, 100] call _speed_limit   // <------------------- Unterprogramm fr bestimmte Geschwindigkeit
            }; 

					//Warten bis Heli sich _dis Meter dem Ziel nhert
					waitUntil {(_h distance myHeliZielPosition < _dis and CurrentWaypoint group _p == (Count Waypoints _p)-1) OR time > _t};
					//Zielanflugroutine beginnt
 					player groupChat format["%1%2",_info select 0,_info select 6];
    			_h flyinHeight _endH;  //Flughhe fr Zieanflug

        	//1. rote Rauchgranate setzen
        	"G_40mm_SmokeRed" createVehicle getPos _l;

          [_h, myHeliZielPosition, _endH+50] call _speed_bremse;   // <------------------------- Unterprogramm fr Geschwindigkeit abbremsen

					// Warten bis Heli beim Ziel eingetroffen
					waitUntil {_h distance myHeliZielPosition < _endH+50 OR time > _t};
				  //Landung einleiten wenn noch "Ladung" im Heli +++++++++++++++++++++++++++++++++++++++ Heli Landung einleiten
				  if (count crew _h > 1) then
            {
            	//2. rote Rauchgranate setzen
              if (speedMode _h == "LIMITED") then {"G_40mm_SmokeRed" createVehicle getPos _l};
    					player groupChat format["%1%2",_info select 0,_info select 3];
              _t=_t+60;//verlngern der "Not-Ausstiegzeit"
            	_h setspeedMode "LIMITED";
            	_h flyinHeight 2;
              _h land "GET OUT";
              waitUntil {count crew _h < 2 OR time > _t}
            }
				}
			else // Alle raus, Heli fliegt allein ins Abseits ab
				{
					{ if (_x != _p) then {_x action["Eject",_h]} } forEach crew _h
				}
		};
	
//_s: Warten bis nchste Helianforderung mglich
	if (count crew _h > 1) then {_s = 100} else {_s = 40};
	if (_t-time < _s) then {_s = _t-time};
	if (_s < 1) then {_s = 1};

//Pilot im Heli?
	if (_p IN _h  and alive _p) then  //Rckflug zur "Basis"   ++++++++++++++++++++++++++++++++++++++++++++++ Heli Abflug
		{
			// Wenn wenn nur noch Pilot im Heli oder "Not-Ausstiegzeit" abgelaufen, dann Wegflug des Helis
			waitUntil {(count crew _h < 2) OR time > _t};
			//Pilot Heli hochziehen
      _h land "NONE";
			_h flyinHeight _geschN * 2;
			_h doMove [getpos _h select 0,getpos _h select 1,_geschN * 2];
			Sleep 7;
			//Pilot neuer Wegpunkt    <=========================================================================== WEGPUNKT ABFLUG HELI IN "BASIS"
			_wp = group _p addWaypoint [[0,0],Count Waypoints _p];
			[group _p, (Count Waypoints _p)-1] SetWaypointType "move";
			group _p setCurrentWaypoint [group _p,Count Waypoints _p];
     	_h setspeedMode _geschA;
     	if (count crew _h > 0) then {player groupChat format["%1%2",_info select 0,_info select 5]}
		}
	else
		{
			//Wenn Pilot nicht im Heli, dann Heli flugunfhig setzen
			_h setDamage 0.8;
			if (_s > 31) then {_s = _s - 30};
			sleep 30
		};

// sind nach Zeitablauf noch mehr als der Pilot im Heli oder ist der Pilot tot oder nicht im Heli, dann wird der Heli jetzt zerstrt.
	if ((count crew _h > 1 AND time > _t) OR not alive _p OR not(_p IN _h)) then {_h setDamage 0.95; sleep _s; _s=1};

//Pilot alle Wegpunkte lschen; Piloten, Heli und Lande H entfernen 
	sleep 20;
	if (count crew _h == 0 AND time < _t AND _S > 1) then {sleep _s; _s=1};
	_p call _clearAllWP;
	deleteVehicle _h;
	deleteVehicle _p;
	deleteVehicle _l;

// neue Helianforderung mglich	
	sleep _s;
	if(myHeliAktiv) then {myHeliAktiv = false; player groupChat format["%1%2",_info select 0,_info select 4]}
